package org.simantics.db.common;

import java.util.TreeMap;

import org.simantics.db.Session;
import org.simantics.db.common.utils.Logger;

public class CommentMetadata extends ACommentMetadata {
    public CommentMetadata(TreeMap<String, byte[]> metadata) {
        super(metadata);
    }

    public CommentMetadata(byte[] data) {
        super(data);
    }

    public static CommentMetadata deserialise(Session session, byte[] input) {
        try {
            return new CommentMetadata(input);
        } catch (Throwable e) {
            Logger.defaultLogError(e);
        }
        return new CommentMetadata((byte[])null);
    }
}
