/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.common.primitiverequest;

import org.simantics.db.AsyncReadGraph;
import org.simantics.db.Resource;
import org.simantics.db.common.request.UnaryAsyncRead;
import org.simantics.db.procedure.AsyncProcedure;

final public class PossibleResource extends UnaryAsyncRead<String, Resource> {

    @Override
    public int getFlags() {
        return 0;
    }

    public PossibleResource(String URI) {
    	super(URI);
    	assert(URI != null);
    }

    @Override
    public void perform(AsyncReadGraph graph, final AsyncProcedure<Resource> procedure) {
        graph.forResource(parameter, new AsyncProcedure<Resource>() {

			@Override
			public void execute(AsyncReadGraph graph, Resource result) {
				procedure.execute(graph, result);
			}

			@Override
			public void exception(AsyncReadGraph graph, Throwable throwable) {
				procedure.execute(graph, null);
			}
        	
        });
    }

}
