/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.common.primitiverequest;

import org.simantics.db.AsyncReadGraph;
import org.simantics.db.Resource;
import org.simantics.db.common.request.ResourceAsyncRead2;
import org.simantics.db.procedure.AsyncProcedure;

final public class PossibleType extends ResourceAsyncRead2<Resource> {

    public PossibleType(Resource resource, Resource resource2) {
        super(resource, resource2);
    }

    @Override
    public void perform(AsyncReadGraph graph, AsyncProcedure<Resource> procedure) {
        
        graph.forPossibleType(resource, resource2, procedure);
        
    }
    
    @Override
    public String toString() {
    	return "PossibleType[" + resource.getResourceId() + " - " + resource2.getResourceId() + "]"; 
    }

}
